'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var react = require('react');
var functionOrder = require('function-order');

//@ts-ignore

var useActionState = function useActionState(props) {
  var _useState = react.useState({}),
      actionState = _useState[0],
      set = _useState[1];

  var cachedFoIns = react.useRef(null);
  var foIns;

  if (cachedFoIns.current) {
    foIns = cachedFoIns.current;
  } else {
    foIns = functionOrder.transformClassToFunctionPipeline(props.action, set);
    cachedFoIns.current = foIns;
  }

  var dispatch = function dispatch(action, runParams) {
    var foIns = functionOrder.transformClassToFunctionPipeline(action, set);
    foIns.run({
      actionState: actionState,
      runParams: runParams
    });
  };

  return {
    actionState: actionState,
    foIns: foIns,
    dispatch: dispatch
  };
};

Object.defineProperty(exports, 'InitKeys', {
    enumerable: true,
    get: function () {
        return functionOrder.InitKeys;
    }
});
exports.useFunctionOrderState = useActionState;
//# sourceMappingURL=react-function-order.cjs.development.js.map
