import { useState, useRef } from 'react';
import { transformClassToFunctionPipeline } from 'function-order';
export { InitKeys } from 'function-order';

//@ts-ignore

var useActionState = function useActionState(props) {
  var _useState = useState({}),
      actionState = _useState[0],
      set = _useState[1];

  var cachedFoIns = useRef(null);
  var foIns;

  if (cachedFoIns.current) {
    foIns = cachedFoIns.current;
  } else {
    foIns = transformClassToFunctionPipeline(props.action, set);
    cachedFoIns.current = foIns;
  }

  var dispatch = function dispatch(action, runParams) {
    var foIns = transformClassToFunctionPipeline(action, set);
    foIns.run({
      actionState: actionState,
      runParams: runParams
    });
  };

  return {
    actionState: actionState,
    foIns: foIns,
    dispatch: dispatch
  };
};

export { useActionState as useFunctionOrderState };
//# sourceMappingURL=react-function-order.esm.js.map
