import { TObj, FunctionPipeline } from 'function-order';
interface Type<T> extends Function {
    new (...args: any[]): T;
}
declare type IProps<T> = {
    action: Type<T>;
};
declare type StateInfo<T> = {
    [props: string]: T;
};
declare type ActionState = {
    [props: string]: any;
    getActionResult: any;
};
export declare type ModifyParams = {
    actionState: ActionState;
    runParams?: any;
};
declare const useActionState: (props: IProps<TObj>) => {
    actionState: StateInfo<any>;
    foIns: FunctionPipeline;
    dispatch: (action: Type<TObj>, runParams?: any) => void;
};
export default useActionState;
